public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
From: "Sam James" <sam@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: sci-libs/openblas/
Date: Thu,  2 May 2024 05:44:02 +0000 (UTC)	[thread overview]
Message-ID: <1714628607.5f8d09e4b1e28f21aae673af7d7e660c217665d4.sam@gentoo> (raw)

commit:     5f8d09e4b1e28f21aae673af7d7e660c217665d4
Author:     Sam James <sam <AT> gentoo <DOT> org>
AuthorDate: Thu May  2 05:43:27 2024 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Thu May  2 05:43:27 2024 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=5f8d09e4

sci-libs/openblas: fix symlinks with USE=eselect-ldso

Closes: https://bugs.gentoo.org/923998
Signed-off-by: Sam James <sam <AT> gentoo.org>

 sci-libs/openblas/openblas-0.3.26-r1.ebuild | 197 ++++++++++++++++++++++++++++
 1 file changed, 197 insertions(+)

diff --git a/sci-libs/openblas/openblas-0.3.26-r1.ebuild b/sci-libs/openblas/openblas-0.3.26-r1.ebuild
new file mode 100644
index 000000000000..9bd2045ad974
--- /dev/null
+++ b/sci-libs/openblas/openblas-0.3.26-r1.ebuild
@@ -0,0 +1,197 @@
+# Copyright 1999-2024 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit flag-o-matic fortran-2 toolchain-funcs
+
+MY_P=OpenBLAS-${PV}
+DESCRIPTION="Optimized BLAS library based on GotoBLAS2"
+HOMEPAGE="https://github.com/xianyi/OpenBLAS"
+SRC_URI="https://github.com/OpenMathLib/OpenBLAS/releases/download/v${PV}/${MY_P}.tar.gz"
+S="${WORKDIR}"/${MY_P}
+
+LICENSE="BSD"
+SLOT="0"
+KEYWORDS="~amd64 ~arm ~arm64 ~loong ~riscv ~x86 ~amd64-linux ~x86-linux ~x64-macos"
+IUSE="dynamic eselect-ldso index-64bit openmp pthread relapack test"
+REQUIRED_USE="?? ( openmp pthread )"
+RESTRICT="!test? ( test )"
+
+RDEPEND="
+	eselect-ldso? (
+		>=app-eselect/eselect-blas-0.2
+		>=app-eselect/eselect-lapack-0.2
+	)
+"
+BDEPEND="virtual/pkgconfig"
+
+PATCHES=(
+	"${FILESDIR}/${PN}-0.3.23-shared-blas-lapack.patch"
+)
+
+pkg_pretend() {
+	[[ ${MERGE_TYPE} != binary ]] && use openmp && tc-check-openmp
+
+	elog "This software has a massive number of options that"
+	elog "are configurable and it is *impossible* for all of"
+	elog "those to fit inside any manageable ebuild."
+	elog "The Gentoo provided package has enough to build"
+	elog "a fully optimized library for your targeted CPU."
+	elog "You can set the CPU target using the environment"
+	elog "variable - OPENBLAS_TARGET or it will be detected"
+	elog "automatically from the target toolchain (supports"
+	elog "cross compilation toolchains)."
+	elog "You can control the maximum number of threads"
+	elog "using OPENBLAS_NTHREAD, default=64 and number of "
+	elog "parallel calls to allow before further calls wait"
+	elog "using OPENBLAS_NPARALLEL, default=8."
+}
+
+pkg_setup() {
+	[[ ${MERGE_TYPE} != binary ]] && use openmp && tc-check-openmp
+
+	fortran-2_pkg_setup
+}
+
+src_prepare() {
+	default
+
+	# TODO: Unbundle lapack like Fedora does?
+	# https://src.fedoraproject.org/rpms/openblas/blob/rawhide/f/openblas-0.2.15-system_lapack.patch
+
+	# Don't build the tests as part of "make all". We'll do
+	# it explicitly later if the test phase is enabled.
+	sed -i -e "/^all :: tests/s: tests::g" Makefile || die
+
+	# If 64bit-index is needed, create second library with LIBPREFIX=libopenblas64
+	if use index-64bit; then
+		cp -aL "${S}" "${S}-index-64bit" || die
+	fi
+}
+
+src_configure() {
+	# List of most configurable options is in Makefile.rule.
+
+	# Not an easy fix, https://github.com/xianyi/OpenBLAS/issues/4128
+	filter-lto
+
+	tc-export CC FC LD AR AS RANLIB
+
+	# HOSTCC is used for scripting
+	export HOSTCC="$(tc-getBUILD_CC)"
+
+	# Threading options
+	export USE_THREAD=0
+	export USE_OPENMP=0
+	if use openmp; then
+		USE_THREAD=1
+		USE_OPENMP=1
+	elif use pthread; then
+		USE_THREAD=1
+		USE_OPENMP=0
+	fi
+
+	# Disable submake with -j and default optimization flags in Makefile.system
+	# Makefile.rule says to not modify COMMON_OPT/FCOMMON_OPT...
+	export MAKE_NB_JOBS=-1 COMMON_OPT=" " FCOMMON_OPT=" "
+
+	# Target CPU ARCH options generally detected automatically from cross toolchain
+	#
+	# TODO: Rename USE=dynamic -> USE=cpudetection like dev-libs/gmp, media-video/ffmpeg?
+	# (may want to then restrict bindist w/ USE=-cpudetection.)
+	if use dynamic ; then
+		export DYNAMIC_ARCH=1 NO_AFFINITY=1 TARGET=GENERIC
+	fi
+
+	export NUM_PARALLEL=${OPENBLAS_NPARALLEL:-8} NUM_THREADS=${OPENBLAS_NTHREAD:-64}
+
+	# Allow setting OPENBLAS_TARGET to override auto detection in case the
+	# toolchain is not enough to detect.
+	# https://github.com/xianyi/OpenBLAS/blob/develop/TargetList.txt
+	if ! use dynamic && [[ ! -z "${OPENBLAS_TARGET}" ]] ; then
+		export TARGET="${OPENBLAS_TARGET}"
+	fi
+
+	export NO_STATIC=1
+	export BUILD_RELAPACK=$(usex relapack 1 0)
+	export PREFIX="${EPREFIX}/usr"
+}
+
+src_compile() {
+	emake shared
+
+	use eselect-ldso && emake -C interface shared-blas-lapack
+
+	if use index-64bit; then
+		emake -C "${S}-index-64bit" \
+			  INTERFACE64=1 \
+			  LIBPREFIX=libopenblas64 shared
+	fi
+}
+
+src_test() {
+	emake tests
+}
+
+src_install() {
+	emake install DESTDIR="${D}" \
+			  OPENBLAS_INCLUDE_DIR='$(PREFIX)'/include/${PN} \
+			  OPENBLAS_LIBRARY_DIR='$(PREFIX)'/$(get_libdir)
+
+	dodoc GotoBLAS_*.txt *.md Changelog.txt
+
+	if use index-64bit; then
+		dolib.so "${S}-index-64bit"/libopenblas64*.so*
+	fi
+
+	if use eselect-ldso; then
+		insinto /usr/$(get_libdir)/blas/openblas/
+		doins interface/libblas.so.3
+		dosym -r /usr/$(get_libdir)/blas/openblas/libblas.so.3 /usr/$(get_libdir)/blas/openblas/libblas.so
+		doins interface/libcblas.so.3
+		dosym -r /usr/$(get_libdir)/blas/openblas/libcblas.so.3 /usr/$(get_libdir)/blas/openblas/libcblas.so
+
+		insinto /usr/$(get_libdir)/lapack/openblas/
+		doins interface/liblapack.so.3
+		dosym -r /usr/$(get_libdir)/lapack/openblas/liblapack.so.3 /usr/$(get_libdir)/lapack/openblas/liblapack.so
+		doins interface/liblapacke.so.3
+		dosym -r /usr/$(get_libdir)/lapack/openblas/liblapacke.so.3 /usr/$(get_libdir)/lapack/openblas/liblapacke.so
+	fi
+}
+
+pkg_postinst() {
+	use eselect-ldso || return
+	local libdir=$(get_libdir) me="openblas"
+
+	# check blas
+	eselect blas add ${libdir} "${EROOT}"/usr/${libdir}/blas/${me} ${me}
+	local current_blas=$(eselect blas show ${libdir} | cut -d' ' -f2)
+	if [[ ${current_blas} == "${me}" || -z ${current_blas} ]]; then
+		eselect blas set ${libdir} ${me}
+		elog "Current eselect: BLAS/CBLAS ($libdir) -> [${current_blas}]."
+	else
+		elog "Current eselect: BLAS/CBLAS ($libdir) -> [${current_blas}]."
+		elog "To use blas [${me}] implementation, you have to issue (as root):"
+		elog "\t eselect blas set ${libdir} ${me}"
+	fi
+
+	# check lapack
+	eselect lapack add ${libdir} "${EROOT}"/usr/${libdir}/lapack/${me} ${me}
+	local current_lapack=$(eselect lapack show ${libdir} | cut -d' ' -f2)
+	if [[ ${current_lapack} == "${me}" || -z ${current_lapack} ]]; then
+		eselect lapack set ${libdir} ${me}
+		elog "Current eselect: LAPACK ($libdir) -> [${current_lapack}]."
+	else
+		elog "Current eselect: LAPACK ($libdir) -> [${current_lapack}]."
+		elog "To use lapack [${me}] implementation, you have to issue (as root):"
+		elog "\t eselect lapack set ${libdir} ${me}"
+	fi
+}
+
+pkg_postrm() {
+	if use eselect-ldso; then
+		eselect blas validate
+		eselect lapack validate
+	fi
+}


             reply	other threads:[~2024-05-02  5:44 UTC|newest]

Thread overview: 58+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2024-05-02  5:44 Sam James [this message]
  -- strict thread matches above, loose matches on Subject: below --
2025-03-10 22:43 [gentoo-commits] repo/gentoo:master commit in: sci-libs/openblas/ Sam James
2024-11-02  9:45 Michał Górny
2024-02-03 19:09 Sam James
2024-01-03  9:48 Sam James
2023-12-18  0:11 Sam James
2023-11-25 12:15 Sam James
2023-11-13  3:28 Sam James
2023-07-17  2:58 Michael Orlitzky
2023-07-13  3:25 Michael Orlitzky
2023-07-09 16:21 Michael Orlitzky
2023-07-07  0:31 Michael Orlitzky
2023-03-07 15:45 Sam James
2022-10-31 14:01 Michael Orlitzky
2022-10-24 15:52 Sam James
2022-05-16  8:12 David Seifert
2022-05-13 14:02 WANG Xuerui
2022-04-27 21:18 Jakov Smolić
2022-03-20 18:51 Sam James
2022-02-21  2:49 Sam James
2022-02-19 19:22 Sam James
2021-12-19 22:44 Sam James
2021-11-05 17:38 Jakov Smolić
2021-11-05 17:34 Sam James
2021-10-06  8:33 Jakov Smolić
2021-10-03  4:32 Sam James
2021-09-14  5:15 Sam James
2021-08-10  4:00 Sam James
2021-07-22  3:32 Sam James
2021-07-22  3:32 Sam James
2021-07-13  4:02 Sam James
2021-05-04 21:25 Sam James
2021-04-18  6:47 Sam James
2021-03-17 23:21 Sam James
2021-01-06 15:17 Fabian Groffen
2020-12-29  8:36 Sam James
2020-12-27  3:37 Sam James
2020-10-29 20:23 Sam James
2020-10-29  9:55 Sam James
2020-10-29  6:38 Sam James
2020-10-08 14:19 Guilherme Amadio
2020-06-25  7:00 Agostino Sarubbo
2020-06-11 23:26 Michael Orlitzky
2020-06-11 23:26 Michael Orlitzky
2020-06-11  2:46 Michael Orlitzky
2020-06-11  2:46 Michael Orlitzky
2020-06-11  2:46 Michael Orlitzky
2020-06-10 20:57 Michael Orlitzky
2020-06-10 20:57 Michael Orlitzky
2020-06-09 21:08 Michael Orlitzky
2020-03-26  4:45 Benda XU
2019-09-04  8:21 Benda XU
2019-08-04 14:47 Benda XU
2019-08-04 13:13 Benda XU
2019-07-24 14:09 Benda XU
2019-07-24 14:09 Benda XU
2019-07-11 11:13 Benda XU
2019-07-11 11:13 Benda XU

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1714628607.5f8d09e4b1e28f21aae673af7d7e660c217665d4.sam@gentoo \
    --to=sam@gentoo.org \
    --cc=gentoo-commits@lists.gentoo.org \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox